# Installing Gitlab DEMO
## Install Requirements
The base folder name must be `gitlabdemo`. Otherwise the Network will not be 
generated with the name `gitlabdemo_gitlab-demo`. If your network name is not `gitlabdemo_gitlab-demo` 
change this in the `postInstall.sh`

## Enable DNS:
**Variant A**

Add a Host Entry (`/etc/hosts`):
```
192.168.60.10 gitlab.demo mattermost.demo project.demo mail.demo
192.168.60.10 [branchname].project.demo
```

**Variant B**

Add a dnsmasq Entry and use 127.0.0.1 as DNS: `/etc/dnsmasq.conf`
```
address=/demo/192.168.60.10
```

## Start the Docker Container
```bash
docker-compose up -d
```

## Run the postInstall Script
```bash
./postInstall.sh
```

## Enable Integrations
- [Test-Coverage](http://gitlab.demo/root/demoproject/settings/ci_cd)
- [Mattermost notifications](http://gitlab.demo/root/demoproject/services/mattermost/edit)
- [Mattermost slash commands](http://gitlab.demo/root/demoproject/services/mattermost/edit)

## Open the Sites
- [Gitlab](http://gitlab.demo)
- [Mattermost (Chat)](http://mattermost.demo)
- [Mailhog (Mailserver)](http://mail.demo)
- [Demo Project](http://project.demo)


# Uninstall

To reset all data run the following command:
```bash
# ATTENTION! This will delete all your unused Docker Images
docker system prune -f -a

gpg --delete-secret-keys $(cat .privkeyID)
```
