#!/usr/bin/env bash


[[ "$1" == "production" ]] && DEPLOY_PATH="live"
[[ "$1" == "branch" && "$2" != "" ]] && DEPLOY_PATH="branch_$2/"
[[ -z "$DEPLOY_PATH" ]] && echo "specify env: production|branch" && exit 1

DEPLOY_PATH="/mnt/webserver/${DEPLOY_PATH}/"
mkdir -p $DEPLOY_PATH
echo "[INFO] Use DEPLOY_PATH: ${DEPLOY_PATH}"

if [[ ! -d vendor ]]; then
    curl -sS https://getcomposer.org/installer | php
    php composer.phar install --ignore-platform-reqs --no-dev
    rm composer.phar
    chown -R gitlab-runner:gitlab-runner vendor
fi

echo "[INFO] rsync current dir " `pwd` " to deploy path"
rsync -rulz --del --exclude-from=.gitignore --exclude=.git ./ ${DEPLOY_PATH}
echo "[INFO] rsync vendor to deploy path"
rsync -rulz --del ./vendor ${DEPLOY_PATH}
