#!/usr/bin/env bash
echo "Generate SSH Key"
ssh-keygen -N "" -b 4096 -f gitlab-demo.ssh
chmod 0400 gitlab-demo.ssh
echo "
=====
"
echo "Paste the key here: http://gitlab.demo/profile/keys"
echo ""
cat <gitlab-demo.ssh.pub
echo "
=====
"
echo "(Press enter to continue)"
read OK
cat >keydata <<EOF
     Key-Type: default
     Subkey-Type: default
     Name-Real: Demo User
     Name-Email: admin@example.com
     Expire-Date: 0
     %commit
     %echo done
EOF
gpg --batch --full-gen-key keydata
rm keydata
KEY_DATA=$(gpg --list-secret-keys --keyid-format LONG admin@example.com)
KEY_ID=$(echo $KEY_DATA | sed 's/sec.*rsa2048\/\(\w*\).*/\1/' | head -n1)
echo "
=====
"
echo "Paste the key here: http://gitlab.demo/profile/gpg_keys"
echo ""
gpg --armor --export $KEY_ID
echo "
=====
"
echo "(Press enter to continue)"
read OK

# Register the gitlab runner
echo "Goto http://gitlab.demo/admin/runners"
echo "Please enter the Runner Token: "
read RunnerToken
docker-compose exec gitlab-runner gitlab-runner register -n -r "$RunnerToken" --name "Demo Runner" --u "http://gitlab.demo" --executor "docker" --docker-image "alpine:latest" --docker-network-mode "gitlabdemo_gitlab-demo"
docker-compose exec gitlab-runner gitlab-runner register -n -r "$RunnerToken" --name "Demo Runner Shell" --u "http://gitlab.demo" --executor "shell" --tag-list "shell"
docker-compose exec gitlab-runner sh -c 'chown -R 999:82 /mnt/webserver'
echo $KEY_ID > .privkeyID

cd demo-project && git init && cd -
sed "s/signkey = .*/signkey = $KEY_ID/g" <docker-compose/config-templates/demo_git-config >demo-project/.git/config
cd demo-project
git add .
git commit -m "Init Project"
git push -u git@gitlab.demo:root/demoproject.git master
cd -


echo "Goto http://gitlab.demo/profile/personal_access_tokens"
echo "Create a Personal Access token with API Access and enter the Token:"
read ApiToken

curl --data "name=Feature&color=#69D100" --header "PRIVATE-TOKEN: ${ApiToken}" "http://gitlab.demo/api/v4/projects/1/labels"
curl --data "name=Bug&color=#FF0000" --header "PRIVATE-TOKEN: ${ApiToken}" "http://gitlab.demo/api/v4/projects/1/labels"
curl --data "description=Update_Pages&ref=master&cron=10 * * * *" --header "PRIVATE-TOKEN: ${ApiToken}" "http://gitlab.demo/api/v4/projects/1/pipeline_schedules"

echo "=========="
echo "DONE"
echo "=========="
